with Ada.Text_Io;
use Ada.Text_Io;

procedure Main is 

   --egy eljaras ami beolvas egy szamot 
   procedure Be (
         Msg  : in     String; 
         Data :    out Integer ) is 
      H : Integer;  
      S : String (1 .. 12);  
   begin
      Put_Line(Msg);
      Get_Line(S,H);
      Data := Integer'Value(S(1..H));
   end Be;

   --letrehozzuk a lista adatszerkezetet 
   type Listaelem; 
   type Plist is access Listaelem; 
   type Listaelem is 
      record 
         E    : Integer;  
         Prev,  
         Next : Plist;  
      end record; 

   L : Plist   := null;  
   U,  
   V,  
   P : Plist;  
   I : Integer;  

begin
   Be("Kerek egy szamot",I);

   while I > 0 loop
      P := new Listaelem;
      P.E := I;

      --ha a lista meg ures, akkor L-t raallitjuk az uj elemre 
      if L = null then
         P.Prev := null;
         P.Next := null;
         L := P;
      else
         --ha nem ures, akkor megkeressuk az elem helyet a listaban 
         U := null;
         V := L;
         while (V/=null) and then (I > V.E) loop
            U := V;
            V := V.Next;
         end loop;
         --ha u = null, akkor a beszurando elem a legkisebb 
         if U = null then
            L := P;
            P.Next := V;
            P.Prev := null;
            V.Prev := P;
         else
            U.Next := P;
            P.Next := V;
            P.Prev := U;
            if V /= null then
               V.Prev := P;
            end if;
         end if;
      end if;
      Be("Kerek egy szamot",I);
   end loop;
   --Az eredmenyek kiirasa 
   P := L;
   while P /= null loop
      Put(Integer'Image(P.E) & "; ");
      P := P.Next;
   end loop;
end Main; 
