with Ada.Unchecked_Deallocation;
package body Sorok is

	procedure Betesz ( S: in out Sor; E: in Elem ) is
		j: Mutat := new Cscs ' (E,null);
	begin
		if S.Vge = null then
			S.Eleje := j;
		else
			S.Vge.Kvetkez := j;
		end if;
		S.Vge := j;
	end Betesz;

	procedure Felszabadt is
		     new Ada.Unchecked_Deallocation(Cscs, Mutat);

	procedure Kivesz ( S: in out Sor; E: out Elem ) is
		Rgi: Mutat := S.Eleje;
	begin
		if Rgi = null then raise res_Sor;
		else	E := Rgi.Adat;
			if  S.Eleje = S.Vge then  S.Vge := null; end if;
			S.Eleje := S.Eleje.Kvetkez;
			Felszabadt(Rgi);
		end if;
	end Kivesz;

	procedure Finalize ( S: in out Sor ) is
		P: Mutat;
	begin
		while S.Eleje /= null loop
			P := S.Eleje;
			S.Eleje := S.Eleje.Kvetkez;
			Felszabadt(P);
		end loop;
	end Finalize;

	procedure Iterl ( S: in Sor ) is
		P: Mutat := S.Eleje;
	begin
		while P /= null loop
			Feladat( P.Adat );
			P := P.Kvetkez;
		end loop;
	end Iterl;

end Sorok;

